/* jsync.c - julians version of the csync stuff */

/*
 * $Header: /nexor/users/jpo/xemp/xemp5.0/lib/csync/RCS/jsync.h,v 1.2 1996/07/17 06:51:52 jpo Exp $
 *
 * $Log: jsync.h,v $
 * Revision 1.2  1996/07/17 06:51:52  jpo
 * New format table
 *
 */

#include <stdio.h>
#include "prototype.h"

#define EDB_STRING 100
#define EDB_STRARRY 101

typedef struct Field {		/* to hold individual fields */
    char *fname;
    int ftype;
    int fsize;
    struct Field *next;
} Field;

typedef struct Object {		/* to hold an object definition */
    int otype;
    int btype;
    Field *field;
    struct Object *next;
} Object;

typedef struct {
    char *tb_name;
    int tb_value;
} CMD_TABLE;

typedef struct {
    char *pc_name;		/* protocol name */
    int xe_number;		/* number of times */
    int xe_type;		/* xemp type */
    int xe_offset;		/* where in the offset */
} Mapping;

struct name2map {
    char *name;
    int code;
    int ssize;
    const Mapping *mp;
    void *(*loc_keyfnx) _PROTO((void *ptr));
    void (*loc_finishfnx) _PROTO((void *ptr));
    void (*loc_dumpfunc) _PROTO((void));
};

#define MAXUSHORT	65535
#define MAXSHORT	32767
#define MAXCHAR		255

typedef struct name2map Name2Mapping;
extern int csync_debug;

extern Name2Mapping nation_map;
extern Name2Mapping sector_obj_map;
extern Name2Mapping sector_class_map;
extern Name2Mapping map_obj_map, bmap_obj_map;
extern Name2Mapping plane_class_map, plane_obj_map;
extern Name2Mapping prod_class_map, item_class_map;
extern Name2Mapping land_obj_map, land_class_map;
extern Name2Mapping ship_class_map, ship_obj_map;
extern Name2Mapping nuke_class_map, nuke_obj_map;
extern void printthing _PROTO((void *thing, const Mapping *map,
			       const char *name));
extern void dumpmaps _PROTO((void));
extern void docopy _PROTO((void *k1, void *k2, const Mapping obj[]));

extern const Mapping *find_mapname _PROTO((const char *str, const Mapping *mp));
extern Name2Mapping *find_map _PROTO((int code));
extern const char *rlookup _PROTO((int n, CMD_TABLE tbl[]));
extern Object *find_object _PROTO((int type));
extern void dump_object _PROTO((FILE *fp));
extern void edb_parse_c_sync _PROTO((char *str));
extern const char *edb_c_sync_type _PROTO((char *str));
extern void dumpfield _PROTO((Field *fp));
extern void doversion _PROTO((char *str));
extern void dumpobj _PROTO((void));
