/*
 * $Header: /nexor/users/jpo/xemp/xemp5.0/lib/csync/RCS/map.c,v 1.2 1996/07/17 06:59:26 jpo Exp $
 *
 * $Log: map.c,v $
 * Revision 1.2  1996/07/17 06:59:26  jpo
 * New format table
 *
 */

#include "toolkit.h"
#include "jsync.h"
#include "main.h"
#include "var.h"
#include "sector.h"

extern struct dchrstr dchr[];

struct j_map {
    short x, y;
    uchar des;
};

static struct j_map j_map;

static void *map_obj_key (ptr)
void *ptr;
{
    j_map.x = j_map.y = MAXSHORT;
    j_map.des = MAXCHAR;
    return &j_map;
}

static void map_obj_final (ptr)
void *ptr;
{
    struct j_map *sp = (struct j_map *)ptr;
    Sector sct;

    sct = World (sp -> x, sp ->y, S_DESIG);
    UpdateSectorDes(sct, sp->des, True);
    DrawSector (sct);
}

#define noffset(x) offsetof(struct j_map, x)

static Mapping map_obj[] = {
    { "x", 1, EDB_SHORT, noffset(x) },
    { "y", 1, EDB_SHORT, noffset(y) },
    { "des", 1, EDB_UCHAR, noffset(des) },
    {NULL},
};
#undef noffset

static void dump_map_obj ()
{
    int x, y;

    for (y = 0; y < MAX_Y; y++)
	for (x = 0; x < MAX_X; x++) {
	    Sector sct = World(x, y, S_EXIST);
	    if (sct)
		printf ("Map %d,%d des=%c\n",
			s_xcd(sct), s_ycd(sct), s_des(sct));
	}
}

struct j_bmap {
    short leftx;
    short rightx;
    short y;
    char *row;
};

static struct j_bmap j_bmap;

static void *bmap_obj_key (ptr)
void *ptr;
{
    return &j_bmap;
}

static void bmap_obj_final(ptr)
void *ptr;
{
    struct j_bmap *sp = (struct j_bmap *)ptr;
    Sector sct;
    char *cp;
    int i;

    for (i = sp -> leftx, cp = sp -> row;
	 i <= sp -> rightx && cp;
	 i += 2, cp++) {
	if (*cp == ' ') continue;
	sct = World (i, sp ->y, S_DESIG);
	UpdateSectorDes(sct, *cp, False);
	DrawSector (sct);
    }
}

#define noffset(x) offsetof(struct j_bmap, x)

static Mapping bmap_obj[] = {
    { "leftx", 1, EDB_SHORT, noffset(leftx) },
    { "rightx", 1, EDB_SHORT, noffset(rightx) },
    { "y", 1, EDB_SHORT, noffset(y) },
    { "row", 1, EDB_STRING, noffset(row) },
    {NULL},
};
#undef noffset

Name2Mapping map_obj_map =
{"map object", MAP_OBJECT, sizeof(struct j_map), map_obj,
 map_obj_key, map_obj_final, dump_map_obj };

Name2Mapping bmap_obj_map =
{"bmap object", BMP_OBJECT, sizeof(struct j_bmap), bmap_obj,
 bmap_obj_key, bmap_obj_final, dump_map_obj };
