/*
 * $Header: /nexor/users/jpo/xemp/xemp5.0/lib/csync/RCS/nation.c,v 1.2 1996/07/17 06:59:39 jpo Exp $
 *
 * $Log: nation.c,v $
 * Revision 1.2  1996/07/17 06:59:39  jpo
 * New format table
 *
 */

#include "toolkit.h"
#include "jsync.h"
#include "main.h"
#include "nation.h"

struct j_nation {
    int btu;
    int cnum;
    char *cname;
    int xstart, ystart;
    long mil_res;
    double level[4];
    double treas;
    long reserve;
    short xcap, ycap;
};

static void *nat_obj_key(ptr)
void *ptr;
{
    static struct j_nation jnat;
    jnat.btu = -MAXSHORT;
    jnat.cnum = -1;
    jnat.cname = NULL;
    jnat.xstart = jnat.ystart = MAXUSHORT;
    jnat.mil_res = -MAXUSHORT;
    jnat.level[0] = jnat.level[1] = jnat.level[2] = jnat.level[3] = -10.0;
    jnat.treas = 0.1;
    jnat.reserve = -MAXUSHORT;
    jnat.xcap = jnat.ycap = MAXSHORT;
    return &jnat;
}

static void nat_obj_final (void *ptr)
{
    extern int capitol_x, capitol_y;
    extern int my_cnum;
    struct j_nation *np = (struct j_nation *)ptr;

    if (nation) {
	if (np -> btu != MAXUSHORT)
	    nation -> btu = np -> btu;
	if (np -> mil_res != -MAXUSHORT)
	    nation -> mil_res = np -> mil_res;
	if (np -> treas != 0.1)
	    nation -> treas = np -> treas;
	if (np -> level[0] != -10.0)
	    nation -> tech = np -> level[0];
	if (np -> level[1] != -10.0)
	    nation -> research = np -> level[1];
	if (np -> level[2] != -10.0)
	    nation -> educ = np -> level[2];
	if (np -> level[3] != -10.0)
	    nation -> hap = np -> level[3];
	if (np -> xcap != MAXSHORT) {
	    capitol_x = np -> xcap;
	    capitol_y = np -> ycap;
	}
	if (np -> cname)
	    AddCountry (np -> cnum, np -> cname);
	if (np -> cnum != -1)
	    my_cnum = np -> cnum;
    }
}

#define noffset(x) offsetof(struct j_nation, x)

static Mapping nat_obj[] = {
    {"cnum", 1, EDB_INT, noffset(cnum)},
    {"cnam", 1, EDB_STRING, noffset(cname)},
    {"xstart", 1, EDB_INT, noffset(xstart) },
    {"ystart", 1, EDB_INT, noffset(ystart) },
    {"xcap", 1, EDB_SHORT, noffset(xcap) },
    {"ycap", 1, EDB_SHORT, noffset(ycap) },
/*      {"tgms", 1, EDB_INT },
	{"ann", 1, EDB_INT },
	{"minused", 1, EDB_INT },
	*/
    {"btu", 1, EDB_INT, noffset(btu) },
    {"reserve", 1, EDB_LONG, noffset (mil_res) },
    {"money", 1, EDB_DOUBLE, noffset (treas) },
    {"level", 4, EDB_DOUBLE, noffset (level) },
    {NULL},
};

static void dump_nation ()
{
    printf ("Nation object btu=%d, res=%ld, treas=%g, tech=%g, res=%g, edu=%g, hap=%g\n",
	    nation -> btu, nation -> mil_res, nation -> treas,
	    nation -> tech, nation -> research,
	    nation -> educ, nation -> hap);
}

Name2Mapping nation_map =
{"nation", NAT_OBJECT, sizeof(struct j_nation), nat_obj,
 nat_obj_key, nat_obj_final, dump_nation };
