/*
 * $Header: /nexor/users/jpo/xemp/xemp5.0/lib/csync/RCS/product.c,v 1.2 1996/07/17 07:00:10 jpo Exp $
 *
 * $Log: product.c,v $
 * Revision 1.2  1996/07/17 07:00:10  jpo
 * New format table
 *
 */

#include "toolkit.h"
#include "jsync.h"
#include "type.h"
#include "var.h"
#include "main.h"

static Mapping prod_obj[] = {
    {"cost", 1, EDB_INT, offsetof (struct pchrstr, p_cost) },
    {"nrndx",1, EDB_INT, offsetof (struct pchrstr, p_nrndx) },
    {"nrdep",1, EDB_INT, offsetof (struct pchrstr, p_nrdep) },
    {"nlndx",1, EDB_INT, offsetof (struct pchrstr, p_nlndx) },
    {"nlmin",1, EDB_INT, offsetof (struct pchrstr, p_nlmin) },
    {"nllag",1, EDB_INT, offsetof (struct pchrstr, p_nllag) },
    {"effic",1, EDB_INT, offsetof (struct pchrstr, p_effic) },
    {"name", 1, EDB_STRING, offsetof (struct pchrstr, p_name)},
    {"sname",1, EDB_STRING, offsetof (struct pchrstr, p_sname)},
    {NULL}
};


extern struct pchrstr pchr[];

static void *prod_class_key (void *ptr)
{
    struct pchrstr *pbase = ptr, *pp;
    static char first = 1;

    if (first) {
	first = 0;
	/* make sure the names are dynamic */
	for (pp = pchr; pp -> p_name; pp++) {
	    pp -> p_sname = strdup(pp -> p_sname);
	    pp -> p_name = strdup(pp->p_name);
	}
    }

    for (pp = pchr; pp -> p_name; pp++) {
	if (strcasecmp (pp -> p_name, pbase -> p_name) == 0)
	    break;
    }
    return pp;
}

static void prod_class_final (ptr)
void *ptr;
{
    struct pchrstr *pp = ptr;
    if (pp -> p_nrndx > 4)
	pp->p_nrndx = pp -> p_nrndx - 26; /* magic at present */
    return;
}

static void dump_prod_class ()
{
    struct pchrstr *pp;

    pp = pchr;
    do {
	pp++;
	printthing (pp, prod_obj, "Product object");
    } while (pp -> p_type != V_RAD);
}

Name2Mapping prod_class_map =
{"product", PRD_CLASS, sizeof(struct pchrstr),
 prod_obj, prod_class_key, prod_class_final, dump_prod_class };


static Mapping item_obj[] = {
    {"mnem", 1, EDB_INT, offsetof (struct ichrstr, i_mnem) },
    {"value",1, EDB_INT, offsetof (struct ichrstr, i_vtype) },
    {"sell", 1, EDB_INT, offsetof (struct ichrstr, i_sell) },
    {"lbs",  1, EDB_INT, offsetof (struct ichrstr, i_lbs) },
    {"pkg",  4, EDB_INT, offsetof (struct ichrstr, i_pkg) },
    {"name", 1, EDB_STRING, offsetof (struct ichrstr, i_name) },
    {NULL}
};


extern struct ichrstr ichr[];

static void *item_class_key (ptr)
void *ptr;
{
    struct ichrstr *pbase = ptr, *pp;
    static char first = 1;

    if (first) {
	first = 0;
	for (pp = &ichr[1]; pp -> i_mnem != 0; pp++)
	    pp -> i_name = strdup(pp->i_name);
    }

    for (pp = &ichr[1]; pp -> i_mnem != 0; pp++) {
	if (pp -> i_mnem == pbase -> i_mnem)
	    break;
    }
    return pp;
}

static void dump_item_class ()
{
    struct ichrstr *pp;

    for (pp = &ichr[1]; pp -> i_mnem != 0; pp++) 
	printthing (pp, item_obj, "Item object");
}

Name2Mapping item_class_map =
{"item", ITM_CLASS, sizeof(struct ichrstr),
 item_obj, item_class_key, NULL, dump_item_class };


