/*
 * $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/lib/csync/RCS/ship.c,v 1.3 1996/07/19 08:25:22 jpo Exp $
 *
 * $Log: ship.c,v $
 * Revision 1.3  1996/07/19 08:25:22  jpo
 * Decided group == fleet
 *
 * Revision 1.2  1996/07/17 07:00:33  jpo
 * New format table
 *
 */

#include "toolkit.h"
#include "jsync.h"
#include "main.h"
#include "ship.h"
#include "sector.h"

extern struct s_shtype shiptypes[];
extern int csync_debug;

static void *ship_class_key (key) 
void *key;
{
    int i;
    struct s_shtype *sbase = key;

    for (i = 0; i < MAX_SHIPTYPES; i++) {
	if (shiptypes[i].nam == 0 ||
	    strcasecmp(shiptypes[i].nam, sbase->nam) == 0)
	    break;
    }
    return &shiptypes[i];
}


static const Mapping sh_obj[] = {
    {"owner", 1, EDB_SHORT, offsetof(struct s_ship, owner) },
    {"uid", 1, EDB_SHORT, offsetof(struct s_ship, nr) },
    {"xloc", 1, EDB_SHORT, offsetof(struct s_ship, x) },
    {"yloc", 1, EDB_SHORT, offsetof(struct s_ship, y) },
    {"type", 1, EDB_SHORT, offsetof(struct s_ship, type) },
    {"effic", 1, EDB_SHORT, offsetof(struct s_ship, eff) },
    {"mobil", 1, EDB_SHORT, offsetof(struct s_ship, mob) },
/*    {"sell", 1, EDB_INT, offsetof(struct s_ship, mob) }, */
    {"tech", 1, EDB_SHORT, offsetof(struct s_ship, tech) },
    {"group", 1, EDB_CHAR, offsetof(struct s_ship, fleet) }, 
    {"opx", 1, EDB_SHORT, offsetof(struct s_ship, rtrtx) },
    {"opy", 1, EDB_SHORT, offsetof(struct s_ship, rtrty) },
    {"mission", 1, EDB_CHAR, offsetof(struct s_ship, mission) },
    {"fleet", 1, EDB_CHAR, offsetof(struct s_ship, fleet) },
    {"nplane", 1, EDB_SHORT, offsetof(struct s_ship, pln) },
    {"fuel", 1, EDB_SHORT, offsetof(struct s_ship, fuel) },
    {"nxlight", 1, EDB_SHORT, offsetof(struct s_ship, xpln) },
    {"nchoppers", 1, EDB_SHORT, offsetof(struct s_ship, heli) },
/*    {"autonav", 1, EDB_UCHAR, offsetof(struct s_ship, autonav) }, */
    {"civil", 1, EDB_SHORT, offsetof(struct s_ship, civ) },
    {"milit", 1, EDB_SHORT, offsetof(struct s_ship, mil) },
    {"shell", 1, EDB_SHORT, offsetof(struct s_ship, shell) },
    {"gun", 1, EDB_SHORT, offsetof(struct s_ship, gun) },
    {"petrol", 1, EDB_SHORT, offsetof(struct s_ship, pet) },
    {"iron", 1, EDB_SHORT, offsetof(struct s_ship, iron) },
    {"dust", 1, EDB_SHORT, offsetof(struct s_ship, dust) },
    {"bar", 1, EDB_SHORT, offsetof(struct s_ship, bar) },
    {"food", 1, EDB_SHORT, offsetof(struct s_ship, food) },
    {"oil", 1, EDB_SHORT, offsetof(struct s_ship, oil) },
    {"lcm", 1, EDB_SHORT, offsetof(struct s_ship, lcm) },
    {"hcm", 1, EDB_SHORT, offsetof(struct s_ship, hcm) },
    {"uw", 1, EDB_SHORT, offsetof(struct s_ship, uw) },
    {"rad", 1, EDB_SHORT, offsetof(struct s_ship, rad) },
    { NULL }
};

static const Mapping sh_class[] = {
    {"name", 1, EDB_STRING, offsetof (struct s_shtype, nam) },
    {"lcm", 1, EDB_INT, offsetof (struct s_shtype, lcm) },
    {"hcm", 1, EDB_INT, offsetof (struct s_shtype, hcm) },
    {"armor", 1, EDB_INT, offsetof (struct s_shtype, def) },
    {"speed", 1, EDB_INT, offsetof (struct s_shtype, spd) },
    {"visib", 1, EDB_INT, offsetof (struct s_shtype, vis) },
    {"vrnge", 1, EDB_INT, offsetof (struct s_shtype, spy) },
    {"frnge", 1, EDB_INT, offsetof (struct s_shtype, rng) },
    {"glim", 1, EDB_INT, offsetof (struct s_shtype, fir) },
    {"nxlight", 1, EDB_INT, offsetof (struct s_shtype, xpl) },
    {"nchoppers", 1, EDB_INT, offsetof (struct s_shtype, hel) },
    {"fuelc", 1, EDB_INT, offsetof (struct s_shtype, fcar) },
    {"fuelu", 1, EDB_INT, offsetof (struct s_shtype, fuse) },
    {"tech", 1, EDB_INT, offsetof (struct s_shtype, tec) },
    {"cost", 1, EDB_INT, offsetof (struct s_shtype, cos) },
    {"flags", 1, EDB_LONG, offsetof(struct s_shtype, flags) },
    {"nplanes", 1, EDB_INT, offsetof (struct s_shtype, pla) },
    {"nland", 1, EDB_INT, offsetof (struct s_shtype, land) },
    {"civil", 1, EDB_INT, offsetof(struct s_shtype, car[V_CIVIL]) },
    {"milit", 1, EDB_INT, offsetof(struct s_shtype, car[V_MILIT]) },
    {"shell", 1, EDB_INT, offsetof(struct s_shtype, car[V_SHELL]) },
    {"gun", 1, EDB_INT, offsetof(struct s_shtype, car[V_GUN]) },
    {"petrol", 1, EDB_INT, offsetof(struct s_shtype, car[V_PETROL]) },
    {"iron", 1, EDB_INT, offsetof(struct s_shtype, car[V_IRON]) },
    {"dust", 1, EDB_INT, offsetof(struct s_shtype, car[V_DUST]) },
    {"bar", 1, EDB_INT, offsetof(struct s_shtype, car[V_BAR]) },
    {"food", 1, EDB_INT, offsetof(struct s_shtype, car[V_FOOD]) },
    {"oil", 1, EDB_INT, offsetof(struct s_shtype, car[V_OIL]) },
    {"lcm", 1, EDB_INT, offsetof(struct s_shtype, car[V_LCM]) },
    {"hcm", 1, EDB_INT, offsetof(struct s_shtype, car[V_HCM]) },
    {"uw", 1, EDB_INT, offsetof(struct s_shtype, car[V_UW]) },
    {"rad", 1, EDB_INT, offsetof(struct s_shtype, car[V_RAD]) },
    { NULL }
};


static void *ship_obj_key (key)
void *key;
{
    Ship ship;
    Sector to;
    Ship nship = (Ship)key;

    ship = NrToShip (sh_nr(nship));
    if (ship == NULL) {
	ship = (Ship) malloc (sizeof *ship);
	*ship = *nship;
	to =  World (sh_xcd(ship), sh_ycd(ship), S_DESIG);
	UpdateSectorDes (to, '.', False);
	AddShipToList(ship);
	SetShipValues (ship, shiptypes[ship->type].nam);
	return ship;
    }
    DeleteShipFromSector (ship);
    DrawSector(World(sh_xcd(ship), sh_ycd(ship), S_DESIG));
    return ship;
}

static void ship_obj_final(ptr)
void *ptr;
{
    Ship ship = ptr;

    set_sh_unmark (ship, MARK_EXISTS);
    AddShipToSector (ship, World(sh_xcd(ship), sh_ycd(ship), S_DESIG));
    DrawSector(World(sh_xcd(ship), sh_ycd(ship), S_DESIG));
    return;
}

static void dump_ship_class ()
{
    int i;
    for (i = 0; shiptypes[i].nam != NULL; i++)
	printthing (&shiptypes[i], sh_class, "Ship class");
}

static void dump_ship_obj ()
{
    Ship ptr;
    for ALL_SHIPS(ptr)
	printthing (ptr, sh_obj, "Ship object");
}


Name2Mapping ship_obj_map =
{"ship object", SHP_OBJECT, sizeof(struct s_ship),
 sh_obj, ship_obj_key, ship_obj_final, dump_ship_obj };

Name2Mapping ship_class_map =
{"ship class", SHP_CLASS, sizeof(struct s_shtype), 
 sh_class, ship_class_key, NULL, dump_ship_class};
